osgSim::ScalarBar Class Reference

`#include <ScalarBar>`

Inheritance diagram for osgSim::ScalarBar:

## Classes

struct | ScalarPrinter
struct | TextProperties

## Public Types

enum | Orientation { HORIZONTAL , VERTICAL }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ScalarBar ()
| ScalarBar (int numColors, int numLabels, ScalarsToColors *stc, const std::string &title, Orientation orientation=HORIZONTAL, float aspectRatio=0.25, ScalarPrinter *sp=new ScalarPrinter)
| ScalarBar (const ScalarBar &rhs, const osg::CopyOp &co)
| META_Node (osgSim, ScalarBar)
void | setNumColors (int numColors)
int | getNumColors () const
void | setNumLabels (int numLabels)
int | getNumLabels () const
void | setScalarsToColors (ScalarsToColors *stc)
const ScalarsToColors * | getScalarsToColors () const
void | setTitle (const std::string &title)
const std::string & | getTitle () const
void | setPosition (const osg::Vec3 &pos)
const osg::Vec3 & | getPosition () const
void | setWidth (float width)
float | getWidth () const
void | setAspectRatio (float aspectRatio)
float | getAspectRatio () const
void | setOrientation (ScalarBar::Orientation orientation)
ScalarBar::Orientation | getOrientation () const
void | setScalarPrinter (ScalarPrinter *sp)
const ScalarPrinter * | getScalarPrinter () const
void | setTextProperties (const TextProperties &tp)
const TextProperties & | getTextProperties () const
void | update ()
Public Member Functions inherited from osg::Geode
| Geode ()
| Geode (const Geode &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Geode)
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual bool | addDrawable (Drawable *drawable)
template<class T>
bool | addDrawable (const ref_ptr< T > &drawable)
virtual bool | removeDrawable (Drawable *drawable)
template<class T>
bool | removeDrawable (const ref_ptr< T > &drawable)
virtual bool | removeDrawables (unsigned int i, unsigned int numDrawablesToRemove=1)
virtual bool | replaceDrawable (Drawable *origDraw, Drawable *newDraw)
template<class T, class R>
bool | replaceDrawable (const ref_ptr< T > &origDraw, const ref_ptr< R > &newDraw)
virtual bool | setDrawable (unsigned int i, Drawable *drawable)
template<class T>
bool | setDrawable (unsigned int i, const ref_ptr< T > &drawable)
unsigned int | getNumDrawables () const
Drawable * | getDrawable (unsigned int i)
const Drawable * | getDrawable (unsigned int i) const
bool | containsDrawable (const Drawable *drawable) const
template<class T>
bool | containsDrawable (const ref_ptr< T > &drawable) const
unsigned int | getDrawableIndex (const Drawable *drawable) const
template<class T>
unsigned int | getDrawableIndex (const ref_ptr< T > &drawable) const
void | compileDrawables (RenderInfo &renderInfo)
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ScalarBar ()
void | createDrawables ()
Protected Member Functions inherited from osg::Geode
virtual | ~Geode ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

int | _numColors
int | _numLabels
osg::ref_ptr< ScalarsToColors > | _stc
std::string | _title
osg::Vec3 | _position
float | _width
float | _aspectRatio
Orientation | _orientation
osg::ref_ptr< ScalarPrinter > | _sp
TextProperties | _textProperties
Protected Attributes inherited from osg::Geode
osg::BoundingBox | _bbox
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A ScalarBar is an osg::Geode to render a colored bar representing a range of scalars. The scalar/color ranges are specified by an instance of ScalarsToColors. There are a number of configurable properties on the ScalarBar, such as the orientation, the number of labels to be displayed across the range, the number of distinct colors to use when rendering the bar, text details etc.

In summary, the main configurables on the ScalarBar are:

1. The range of scalars represented by the bar, and the colors corresponding to this range - these are specified by the ScalarsToColors object.
2. The number of colors used when rendering the bar geometry - this may be thought of as the bar 'density'.
3. The number of text labels to be used when displaying the bar.

The other configurables should be self-explanatory.

## Member Enumeration Documentation

## Orientation

enum osgSim::ScalarBar::Orientation

ScalarBar orientation specification.

Enumerator
HORIZONTAL | a horizontally ascending scalar bar (x-axis)
VERTICAL | a vertically ascending scalar bar (y-axis)

## Constructor & Destructor Documentation

## ScalarBar() [1/3]

osgSim::ScalarBar::ScalarBar | ( |  | ) |

inline

Default constructor.

References _aspectRatio, _numColors, _numLabels, _orientation, _position, _sp, _stc, _title, _width, createDrawables(), osg::Geode::Geode(), and HORIZONTAL.

Referenced by META_Node(), and ScalarBar().

## ScalarBar() [2/3]

osgSim::ScalarBar::ScalarBar | ( | int | numColors,
|  | int | numLabels,
|  | ScalarsToColors * | stc,
|  | const std::string & | title,
|  | Orientation | orientation = HORIZONTAL,
|  | float | aspectRatio = 0.25,
|  | ScalarPrinter * | sp = new ScalarPrinter )

inline

Construct a ScalarBar with the supplied parameters.

Parameters

  numColors | Specify the number of colors in the scalar bar. Color interpolation occurs where necessary.
  numLabels | Specify the number of labels in the scalar bar.
  stc | The ScalarsToColors defining the range of scalars and the colors they map to.
  title | The title to be used when displaying the ScalarBar. Specify "" for no title.
  orientation | The orientation of the ScalarBar.

See also
  Orientation.

Parameters

  aspectRatio | The aspect ration (y/x) for the displayed bar. Bear in mind you may want to change this if you change the orientation.
  sp | A ScalarPrinter object for the ScalarBar. For every displayed ScalarBar label, the scalar value will be passed to the ScalarPrinter object to turn it into a string. Users may override the default ScalarPrinter object to map scalars to whatever strings they wish.

See also
  ScalarPrinter

References _aspectRatio, _numColors, _numLabels, _orientation, _position, _sp, _stc, _title, _width, createDrawables(), osg::Geode::Geode(), and HORIZONTAL.

## ScalarBar() [3/3]

osgSim::ScalarBar::ScalarBar | ( | const ScalarBar & | rhs,
|  | const osg::CopyOp & | co )

inline

Copy constructor

References _aspectRatio, _numColors, _numLabels, _orientation, _position, _sp, _stc, _textProperties, _title, _width, osg::Geode::Geode(), and ScalarBar().

## ~ScalarBar()

virtual osgSim::ScalarBar::~ScalarBar | ( |  | ) |

protected virtual

## Member Function Documentation

## createDrawables()

void osgSim::ScalarBar::createDrawables | ( |  | ) |

protected

Referenced by ScalarBar(), ScalarBar(), and update().

## getAspectRatio()

float osgSim::ScalarBar::getAspectRatio | ( |  | ) | const

Get the aspect ration (y/x) for the displayed bar.

## getNumColors()

int osgSim::ScalarBar::getNumColors | ( |  | ) | const

Get the number of distinct colours on the ScalarBar.

## getNumLabels()

int osgSim::ScalarBar::getNumLabels | ( |  | ) | const

Get the number of labels displayed along the ScalarBar.

## getOrientation()

ScalarBar::Orientation osgSim::ScalarBar::getOrientation | ( |  | ) | const

Get the orientation of the ScalarBar.

See also
  Orientation

## getPosition()

const osg::Vec3 & osgSim::ScalarBar::getPosition | ( |  | ) | const

inline

Get the position of scalar bar.

References _position.

## getScalarPrinter()

const ScalarPrinter * osgSim::ScalarBar::getScalarPrinter | ( |  | ) | const

Get the ScalarPrinter object

## getScalarsToColors()

const ScalarsToColors * osgSim::ScalarBar::getScalarsToColors | ( |  | ) | const

Get the ScalarsToColors mapping object from the ScalarBar.

## getTextProperties()

const TextProperties & osgSim::ScalarBar::getTextProperties | ( |  | ) | const

Get the TextProperties for the labels & title.

See also
  TextProperties

## getTitle()

const std::string & osgSim::ScalarBar::getTitle | ( |  | ) | const

Get the title for the ScalarBar.

## getWidth()

float osgSim::ScalarBar::getWidth | ( |  | ) | const

inline

Get the width of the scalar bar.

References _width.

## META_Node()

osgSim::ScalarBar::META_Node | ( | osgSim | ,
|  | ScalarBar | )

References ScalarBar().

## setAspectRatio()

void osgSim::ScalarBar::setAspectRatio | ( | float | aspectRatio | ) |

Set the aspect ration (y/x) for the displayed bar. Bear in mind you may want to change this if you change the orientation.

## setNumColors()

void osgSim::ScalarBar::setNumColors | ( | int | numColors | ) |

Set the number of distinct colours on the ScalarBar.

## setNumLabels()

void osgSim::ScalarBar::setNumLabels | ( | int | numLabels | ) |

Set the number of labels to display along the ScalarBar. There will be one label at each end point, and evenly distributed labels in between.

## setOrientation()

void osgSim::ScalarBar::setOrientation | ( | ScalarBar::Orientation | orientation | ) |

Set the orientation of the ScalarBar.

See also
  Orientation

## setPosition()

void osgSim::ScalarBar::setPosition | ( | const osg::Vec3 & | pos | ) |

Set the position of scalar bar's lower left corner.

## setScalarPrinter()

void osgSim::ScalarBar::setScalarPrinter | ( | ScalarPrinter * | sp | ) |

Set a ScalarPrinter object for the ScalarBar. For every displayed ScalarBar label, the scalar value will be passed to the ScalarPrinter object to turn it into a string. Users may override the default ScalarPrinter object to map scalars to whatever strings they wish.

See also
  ScalarPrinter

## setScalarsToColors()

void osgSim::ScalarBar::setScalarsToColors | ( | ScalarsToColors * | stc | ) |

Set the ScalarsToColors mapping object for the ScalarBar.

## setTextProperties()

void osgSim::ScalarBar::setTextProperties | ( | const TextProperties & | tp | ) |

Set the TextProperties for the labels & title.

See also
  TextProperties

## setTitle()

void osgSim::ScalarBar::setTitle | ( | const std::string & | title | ) |

Set the title for the ScalarBar, set "" for no title.

## setWidth()

void osgSim::ScalarBar::setWidth | ( | float | width | ) |

Set the width of the scalar bar.

## update()

void osgSim::ScalarBar::update | ( |  | ) |

inline

force update the drawables used to render the scalar bar.

References createDrawables().

## Member Data Documentation

## _aspectRatio

float osgSim::ScalarBar::_aspectRatio

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _numColors

int osgSim::ScalarBar::_numColors

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _numLabels

int osgSim::ScalarBar::_numLabels

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _orientation

Orientation osgSim::ScalarBar::_orientation

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _position

osg::Vec3 osgSim::ScalarBar::_position

protected

Referenced by getPosition(), ScalarBar(), ScalarBar(), and ScalarBar().

## _sp

osg::ref_ptr<ScalarPrinter> osgSim::ScalarBar::_sp

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _stc

osg::ref_ptr<ScalarsToColors> osgSim::ScalarBar::_stc

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _textProperties

TextProperties osgSim::ScalarBar::_textProperties

protected

Referenced by ScalarBar().

## _title

std::string osgSim::ScalarBar::_title

protected

Referenced by ScalarBar(), ScalarBar(), and ScalarBar().

## _width

float osgSim::ScalarBar::_width

protected

Referenced by getWidth(), ScalarBar(), ScalarBar(), and ScalarBar().

The documentation for this class was generated from the following file:

- ScalarBar